---
title: Other things you may like
description: A nonexhaustive list of... content/media... which I like and which you may also be interested in as a visitor of my site.
created: 11/06/2020
updated: 17/11/2020
slug: otherstuff
---
I'm excluding music from this because music preferences seem to be even more varied between the people I interact with than other stuff.
Obviously this is just stuff *I* like; you might not like it, which isn't really my concern - this list is primarily made to bring to people's attention stuff they might like but have not heard of.

* [SCP Foundation - Antimemetics Divison](http://www.scp-wiki.net/antimemetics-division-hub) by qntm - fiction about antimemes ("ideas with self-censoring properties") in the [SCP](https://en.wikipedia.org/wiki/SCP_Foundation) universe. Cosmic horror and pretty good. Now completed except for an epilogue. You can read some other work by the author, on [their website](https://qntm.org).
* [Mother of Learning](https://www.fictionpress.com/s/2961893/1/Mother-of-Learning) by nobody103, 823k words, now completed. I'll just copy the summary from FictionPress here: "Zorian, a mage in training, only wanted to finish his education in peace. Now he struggles to find answers as he finds himself repeatedly reliving the same month. 'Groundhog Day' style setup in a fantasy world.".
* [The Hitchhiker's Guide to The Galaxy](https://www.goodreads.com/series/40957-hitchhiker-s-guide-to-the-galaxy) by Douglas Adams (a series). It is pretty popular but quite a few people aren't aware of it, which is a shame. It's basically (very funny) scifi comedy.
* [Sufficiently Advanced Magic](https://www.goodreads.com/book/show/34403860-sufficiently-advanced-magic) by Andrew Rowe. Progression fantasy with an interesting magic system. It's part of a series containing two books so far (unfinished).
* [Mistborn](https://www.goodreads.com/series/40910-mistborn) by Brandon Sanderson. Initially seems like a pretty standard "chosen one must defeat the evil empire"-type story, is actually much more complex.
* [Discworld](https://en.wikipedia.org/wiki/Discworld) by Terry Pratchett, a *very* long-running (41 books, but it's sort of made of various miniserieses so you don't really need to read all of them or in order) fantasy series set on the "Discworld", a flat world on the back of four elephants on a turtle. As you might expect from that description, it's somewhat comedic, but also has long-running plot arcs, great character development, and a world not stuck in medieval stasis (as new technology is introduced and drives some of the plots).
  * He has good collaboratively-written books like [The Long Earth](https://www.goodreads.com/book/show/13147230-the-long-earth) and Good Omens (mentioned below).
* [Minecraft](https://www.minecraft.net/en-us/). You've probably heard of it, as it's apparently the most popular computer game ever, but it seems worth listing. It's a block-based sandbox game in which you can do a lot of stuff. 
  * Java Edition, which you should probably be playing anyway instead of the mobile version/Windows 10 Edition/Bedrock Edition/the console one/whatever else because it lacks the horrible, horrible microtransactions Microsoft implemented, has mod support, allowing you to use a *huge* range of extra content for free. This includes stuff like [programmable computers](https://www.curseforge.com/minecraft/mc-mods/cc-tweaked), [machines and stuff](https://www.curseforge.com/minecraft/mc-mods/thermal-expansion), [new "dimensions"](https://www.curseforge.com/minecraft/mc-mods/the-twilight-forest) (I do NOT like this use of this word but it's seeped into popular terminology), a complex [magic system](https://www.curseforge.com/minecraft/mc-mods/thaumcraft) (note that this is no longer updated, you should consider Astral Sorcery and Botania and other modern ones which are), and this [one modpack](https://www.technicpack.net/modpack/mcnewhorizons.677387) (well, there are probably others) with incredibly complex progression which could take [months](https://www.youtube.com/playlist?list=PLliiJ70rl2NvJjby2LoVuP1EuOvRAyf97) to finish.
  * There's also [Minetest](https://www.minetest.net/), a free and open source game in the style of Minecraft, which I mention for completeness - it's much better from a technical perspective, and free, but also significantly less polished and I don't really like it.. 
* [Factorio](https://factorio.com/), a 2D factory building game where you can make intricate and sprawling factories to... produce science packs, mostly. Extremely well-optimized so that you can have vast amounts of machines without speed dropping to unusable levels, without problematic hacks like Minecraft's chunkloading.
* [FTL: Faster than Light](https://subsetgames.com/ftl.html), a very replayable roguelite (with nice music, too) with tactical real-time (spaceship) combat and difficult choices. I have a page with (spoilery) tips [here](/FTL).
* [Universe Sandbox](http://universesandbox.com/), a game/simulator in which you can meddle with the very stars (and planets) in the skies.
* The [Edge Chronicles](https://en.wikipedia.org/wiki/The_Edge_Chronicles) by Paul Stewart and Chris Riddel, a "high fantasy" (in the sense that it has large-scale plots and is set in a very non-real-world-like world) book series which is... well, apparently a children's series, and it is in many ways, but it's also somewhat darker than usual for that. Has nice illustrations.
* [Sixteen Ways to Defend a Walled City](https://www.goodreads.com/book/show/37946419-sixteen-ways-to-defend-a-walled-city) by K. J. Parker. A funny book about an engineer leading the defense of a city against a siege.
* [Doing God's Work](https://www.royalroad.com/fiction/25442/doing-gods-work), a web serial in which "The gods are real and incorporated. Providence is a profitable global monopoly."
* [styropyro](https://youtube.com/user/styropyro/), the top search result for "crazy laser guy". Builds interesting lasery things (also Tesla coils and whatnot). Also has a [Discord server](https://discord.gg/ckGrMDR), which hosts many interesting discussions about primarily lasers and electronics, but many other things too.
* [Towers of Heaven](https://www.goodreads.com/series/264587-towers-of-heaven) by Cameron Milan, a [LitRPG](https://en.wikipedia.org/wiki/LitRPG) series about someone travelling back in time to save humanity from extinction because of the arrival of the towers, invulnerable extremely tall... towers... containing challenges (and which also release monsters periodically on the world around them, hence the "extinction" thing).
* [Ender's Game](https://en.wikipedia.org/wiki/Ender%27s_Game) by Orson Scott Card, a scifi book about children being trained to be the next leaders in soldiers in humanity's war with some aliens. I am not really a fan of the sequels.
* [Chilli and the Chocolate Factory](https://www.fanfiction.net/s/13451176/1/Chili-and-the-Chocolate-Factory-Fudge-Revelation) by gaizemaize, a now-completed web serial. It is, unsurprisingly, Charlie and the Chocolate Factory fanfiction which is actually pretty good. It manages to capture the bizarre surreal spirit of the original one, and is very funny. I vaguely suspect that the whole thing might just be convoluted setup for a pun.
* [UNSONG](http://unsongbook.com/) by Scott Alexander, which is *also* a now-completed web serial. A bizarre world in which, after Apollo 8 crashes into the crystal sphere surrounding the world, the planet switches over to running on kabbalistic Judaism. It sounds very weird, and it *is*, but it's a good story.
* [Friendship is Optimal](http://www.fimfiction.net/story/62074/friendship-is-optimal) by Iceman, a cautionary tale about unfriendly AI.
* [Good Omens](https://en.wikipedia.org/wiki/Good_Omens) by Neil Gaiman and Terry Pratchett, a "comedy about the birth of the son of Satan and the coming of the End Times" as Wikipedia puts it. You might think it would be hard to make a comedy out of it, but they manage very well.
* [The Expanse](https://www.goodreads.com/series/56399-the-expanse) by James S. A. Corey, a near-future-ish scifi series in space which actually bothers with some level of realism. Also a TV series now if you prefer those.
* [Three Parts Dead](https://www.goodreads.com/book/show/13539191-three-parts-dead) by Max Gladstone, a very neat fantasy book (part of a series, have not yet read the others) with a well-built world where gods work somewhat like modern corporations. The basic plot: "A god has died, and it’s up to Tara, first-year associate in the international necromantic firm of Kelethres, Albrecht, and Ao, to bring Him back to life before His city falls apart."
* [We Are Legion (We Are Bob)](https://www.goodreads.com/book/show/32109569-we-are-legion-we-are-bob) by Dennis E. Taylor, a story of von Neumann probes managed by uploaded human intelligences.
* [The Combat Codes](https://www.goodreads.com/book/show/27790093-the-combat-codes) by Alexander Darwin. Similar to Ender's Game, but with MMA, basically, and I am bad at describing things.
* [Schlock Mercenary](https://www.schlockmercenary.com/), a *very* long-running space opera webcomic. It's been running for something like 20 years, and the art and such improve over time.
* [Freefall](http://freefall.purrsia.com/), a hard-science-fiction webcomic.
* [Mage Errant](https://www.goodreads.com/series/252085-mage-errant) - a moderately-long-by-now fantasy series with a very vibrant world, and which actually considers the geopolitical implications of there being beings around ("Great Powers") able to act as one-man armies.
* [Arcane Ascension](https://www.goodreads.com/series/201441-arcane-ascension) - fun progression fantasy series with (... like most of these, actually) worldbuilding I like and good characters. I have only read the first two, since I'm writing this just as the third came out

Special mentions (i.e. "I haven't gotten around to reading these but they are well-reviewed and sound interesting") to:
* [The Divine Cities](https://www.goodreads.com/series/159695-the-divine-cities) by Robert Jackson Bennet.
* [Children of Time](https://www.goodreads.com/book/show/25499718-children-of-time) by Adrian Tchaikovsky.
* [The Murderbot Diaries](https://www.goodreads.com/series/191900-the-murderbot-diaries) by Martha Wells.
* [Codex Alera](https://www.goodreads.com/series/45545-codex-alera) by Jim Butcher.
* [Digitesque](https://www.goodreads.com/series/183319-digitesque) by Guerric Haché.
* [This Is How You Lose The Time War](https://www.goodreads.com/book/show/43352954-this-is-how-you-lose-the-time-war) by Amal El-Mohtar, Max Gladstone.
* [The Machineries of Empire](https://www.goodreads.com/series/160439-the-machineries-of-empire) by Yoon Ha Lee.
* [The Books of Babel](https://www.goodreads.com/series/127130-the-books-of-babel) by Josiah Bancroft.
* [House of Suns](https://www.goodreads.com/book/show/1126719.House_of_Suns) by Alastair Reynolds.
  * "house of suns is really very good, you should read" - baidicoot/Aidan, creator of the world-renowned [Emu War](/emu-war) game

If you want EPUB versions of the free web serial stuff here for your e-reader, there are tools to generate those, or you can contact me for a copy.

You can suggest other possibly-good stuff in the comments and I may add it to an extra section, and pointlessly complain there or [by email](mailto:osmarks@protonmail.com) if you don't like some of this. Please tell me if any links are dead.
